require 'json'

module Flagger

  class Group

    def initialize(id, **args)
      @id = id.to_s
      unless args.empty?
        @type = args.has_key?(:type) ? args[:type].to_s : nil
        @name = args.has_key?(:name) ? args[:name].to_s : nil
        @attributes = args.has_key?(:attributes) ? args[:attributes].to_s : nil
      end

    end

    def to_json
      {
          id: @id,
          name: @name,
          attributes: @attributes
      }.compact.to_json
    end
  end


  class Entity

    def initialize(id, **args)
      @id = id.to_s
      unless args.empty?
        @type = args.has_key?(:type) ? args[:type].to_s : nil
        @name = args.has_key?(:name) ? args[:name].to_s : nil
        @attributes = args.has_key?(:attributes)? args[:attributes] : nil
        @group = args.has_key?(:group) ? args[:group] : nil
      end
    end

    def to_json
      {
          id: @id,
          name: @name,
          type: @type,
          attributes: @attributes,
          group: @group
      }.compact.to_json
    end
  end
end