require 'os'

def __load_lib(name)
  arch = OS.bits === 32 ? '386' : 'amd64'
  if OS.windows?
    name = name + '-' + arch + '.dll'
  elsif OS.mac?
    name = 'lib' + name + '.dylib'
  elsif OS.linux?
    name = 'lib' + name + '-' + arch + '.so'
  else
    raise 'unsupported platform'
  end
  File.join File.dirname(__FILE__), name
end

# Module that represents shared lib
module FlaggerNative
  extend FFI::Library
  ffi_lib __load_lib('flagger')
# foreign function definitions
  attach_function :Init, [:string], :string
  attach_function :Publish, [:string], :string
  attach_function :Track, [:string], :string
  attach_function :SetEntity, [:string], :string
  attach_function :FlagIsEnabled, [:string], :string
  attach_function :FlagIsSampled, [:string], :string
  attach_function :FlagGetVariation, [:string], :string
  attach_function :FlagGetPayload, [:string], :string
  attach_function :Shutdown, [:string], :string
end
